#pragma once

#include "GenTLCamera.h"

#include <string>





namespace GenTLConsumerImplHelper
{
    CIH_WEAK_SYMBOL(extern const char ToFProducerName[]);

    class CToFCamera : public CGenTLCamera<ToFProducerName>
    {
    public:
#pragma pack(push, 1)
        struct Coord3D
        {
            float x;
            float y;
            float z;
            bool IsValid() const { return z == z; }  // check for NAN
        };
#pragma pack(pop)


    public:
        CToFCamera()
        {

        }

    protected:

    private:
        // Prevent copying.
        CToFCamera( const CToFCamera& );
        CToFCamera& operator=(const CToFCamera& );

    };

}

#ifndef USE_DEBUG_CONSUMER
    extern const char GenTLConsumerImplHelper::ToFProducerName[] = "ProducerTOF.cti";
#else
    extern const char GenTLConsumerImplHelper::ToFProducerName[] = "ProducerTOF_d.cti";
#endif

template<>
std::string GenTLConsumerImplHelper::CGenTLCamera<GenTLConsumerImplHelper::ToFProducerName>::s_NonCachedParameter = "DeviceTemperature";
